#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "lcd_routines.h" //Diese Datei ist nicht von mir, und nur geringfgig an das Display angepasst. Ich bin der meinung das hier einiges nicht so luft wie es soll, aber es funktioniert halbwegs
#include "safe_input.h" //Hier werden Eingnge entprellt
#include <string.h> //fr strlen

#define     IN          SI_PORTA
#define     OUT         PORTB
#define     DISABLE     0x00

#define     TOR_OPEN      0
#define     TOR_CLOSE     1

#define     TASTE_AUF     3
#define     TASTE_ZU      2
#define     TASTE_STOP    4

#define     SCHALTER_OBEN  1
#define     SCHALTER_UNTEN 5

//circa 10ms bei 8 MHz
#define     PRESCALER       (1<<CS00) | (1<<CS02);
#define     PRELOAD         178


static volatile unsigned long long int millisecs = 0;
static volatile int slider = 0;
static volatile int slider_step = 0;
char *slider_text;

void slide(char *s, int step)
{
    lcd_clear();
    step %= strlen(s); //irgendwann auch mal von vorne anfangen
    lcd_setcursor(0, 1);
    unsigned int i = 0;

    for(i = 0; i < 8; i++)
    {
        {
            lcd_data(s[(i + step) % strlen(s)]); //Schriftzug als Lauftext anzeigen
        }

    }

	//Debuginfos auf dem Display anzeigen
    lcd_setcursor(1, 2);
    lcd_data('0' + SI_pin(IN, TASTE_AUF));
    lcd_data('0' + SI_pin(IN, TASTE_STOP));
    lcd_data('0' + SI_pin(IN, TASTE_ZU));
    lcd_data(' ');
    lcd_data('0' + SI_pin(IN, SCHALTER_OBEN));
    lcd_data('0' + SI_pin(IN, SCHALTER_UNTEN));
}

ISR (TIMER0_OVF_vect)
{
    millisecs += 10;
    TCNT0 = PRELOAD;

	//Muss periodisch aufgefhrt werden um Eingnge zu entprellen
    SI_check_input();

    if(!(millisecs % 500)) //ab und zu mal das Display aktualisieren. Kleinerer wert bedeutet schnellerer Lauftext. Zu schnell wird unleserlich wegen der Trgheit des lcd-displays!
    {
        if(slider)
        {
            slider_step++;
            slide(slider_text, slider_step);
        }
        else
        {
            slider_step = 0;
        }
    }
}

int main(void)
{

    DDRB = 0x03;

    DDRA = 0x00;

    DDRC = 0xFF;

    SI_activate_port(SI_PORTA); //Nur porta entprellen, rest ignorieren (spart zeit)


    //Lauftext frs Display initlialisieren
    slider = 0;
    slider_step = 0;
    slider_text = "S && B >> AVR GATE CONTROL V 1.0b << ";



    lcd_init();

	//Lauftext starten
    slider = 1;


    TCCR0 = PRESCALER;
    TIMSK |= (1 << TOIE0);
    sei();

    while(1)
    {
        if(SI_pin(IN, TASTE_AUF) && !SI_pin(IN, TASTE_ZU)) //Nach oben Taste checken
        {
            if(SI_pin(IN, SCHALTER_OBEN) && !(OUT & (1 << TOR_CLOSE))) //checken obs nicht schon am ende ist, oder bereits nach unten fhrt
            {
                OUT = (1 << TOR_OPEN);
            }

        }

        if(OUT & (1 << TOR_OPEN) && !SI_pin(IN, SCHALTER_OBEN)) //wenn es nach oben fhrt und den endschalter bettigt
        {
            OUT = DISABLE; //dann anhalten
        }

        if(SI_pin(IN, TASTE_ZU) && !SI_pin(IN, TASTE_AUF)) //Nach unten taste checken
        {
            if(!SI_pin(IN, SCHALTER_UNTEN) && !(OUT & (1 << TOR_OPEN))) //ckecnen obs nicht schon ganz unten ist, oder nach oben fhrt
            {
                OUT = (1 << TOR_CLOSE);
            }

        }

        if(OUT & (1 << TOR_CLOSE) && SI_pin(IN, SCHALTER_UNTEN)) //wenn es nach unten fhrt und den endschalter bettigt
        {
            OUT = DISABLE; //dann anhalten
        }

        if(SI_pin(IN, TASTE_STOP)) //Wenn stopptaster gedrckt wird
        {
            OUT = DISABLE; //sofort anhalten!
        }
    }

    return 0; //Sollte niemals erreicht werden!
}
