
#include "safe_input.h"

static int INPUT[4*8]; //Ein Array frs entprellen
static int ACTIVE_PORT[4] = {0, 0, 0, 0}; //Was soll berhaupt berprft werden?

void SI_activate_port(int port)
{
    ACTIVE_PORT[port] = 1;
}
void SI_deactivate_port(int port)
{
    ACTIVE_PORT[port] = 0;
}

void SI_check_input(void)
{
    int port = 0;
    int bit = 0;
    int tmp = 0;

    for(port = 0; port < 4; port++)
    {
        if(ACTIVE_PORT[port])
        {
            for(bit = 0; bit < 8; bit++)
            {
                switch(port)
                {
                    case SI_PORTA:
                    {
                        if(PINA & (1 << bit))
                        {
                            tmp = 1; //Wenn PINX ist aktiv, dann merken
                        }
                        else
                        {
                            tmp = 0; //Wenn PINX ist aktiv, dann ___NICHT___ merken
                        }
                    } break;
                    case SI_PORTB:
                    {
                        if(PINB & (1 << bit))
                        {
                            tmp = 1;
                        }
                        else
                        {
                            tmp = 0;
                        }
                    } break;
                    case SI_PORTC:
                    {
                        if(PINC & (1 << bit))
                        {
                            tmp = 1;
                        }
                        else
                        {
                            tmp = 0;
                        }
                    } break;
                    case SI_PORTD:
                    {
                        if(PIND & (1 << bit))
                        {
                            tmp = 1;
                        }
                        else
                        {
                            tmp = 0;
                        }
                    } break;
                }

                if(tmp) //Wenn der Pin High war...
                {
                    if(INPUT[port * 8 + bit] < SI_SAFETIME + 1) //und die entprellung noch nicht am "ende" ist...
                    {
                        INPUT[port * 8 + bit]++; //dann hochzhlen
                    }
                }
                else
                {
                    if(INPUT[port * 8 + bit] > 0) //Ansonsten halt
                    {
                        INPUT[port * 8 + bit]--; //decreasen
                    }

                }
            }
        }
    }
}

int SI_pin(int port, int bit)
{
    if(INPUT[port * 8 + bit] >= SI_SAFETIME / 2) //Wenn der pin die hlfte der safe-zeit erreicht hat, ist er "ein"...
    {
        return 1; //Dadurch erreicht mal mehr oder weniger eine Hysterese
    }
    return 0;
}

